<template>
  <div class="app-container">
    <!--筛选条件-->
    <div class="search-div">
      <el-form ref="selectForm" :inline="true" :model="listQuery" class="form-container">
        <el-row>
          <el-form-item class="selectForm-container-item" prop="devcode">
            <el-input v-model.trim="listQuery.devcode" placeholder="设备编号" clearable/>
          </el-form-item>
          <el-button class="filter-item" type="primary" icon="el-icon-search" @click="search">搜索</el-button>
        </el-row>
      </el-form>
    </div>
    <!--查询结果Table显示-->
    <div>
      <el-row class="table-title">
        <el-col :span="6"><div class="title-header"><i class="el-icon-menu"/>数据列表</div></el-col>
        <el-col :span="12" :offset="6" class="edit_btns">
          <!--<el-button class="edit_btn" size="small" @click="batchExport">导出记录</el-button>-->
          <download-template v-if="hasPerm('/nbdevice/batchImport')" :filename="filename"/>
          <el-upload
            v-if="hasPerm('/nbdevice/batchImport')"
            :limit="1"
            :show-file-list="false"
            :http-request="uploadFile"
            :file-list="fileList"
            action="string"
            accept=".xls,.xlsx"
            class="edit_btn">
            <el-button slot="trigger" size="small">批量导入</el-button>
          </el-upload>
          <el-button v-if="hasPerm('/nbdevice/delete')" class="edit_btn" size="small" @click="del">删除</el-button>
          <el-button v-if="hasPerm('/nbdevice/add')" class="edit_btn" size="small" @click="add">新增</el-button>

        </el-col>
      </el-row>
      <el-table v-loading="listLoading" :data="list" class="table" border @selection-change="handleSelectionChange">
        <el-table-column align="center" type="selection" width="55"/>
        <el-table-column :index="indexMethod" align="center" type="index"/>
        <el-table-column v-for="column in columns" :key="column.value" :label="column.text" :width="column.width" :align="column.align" show-overflow-tooltip>
          <template slot-scope="scope">
            {{ scope.row[column.value] }}
          </template>
        </el-table-column>
        <el-table-column v-if="hasPerm('/nbdevice/update')" label="操作" align="center" width="60">
          <template slot-scope="scope">
            <el-button v-if="hasPerm('/nbdevice/update')" type="text" @click="edit(scope.row)">编辑</el-button>
          </template>
        </el-table-column>
      </el-table>
    </div>
    <!--分页-->
    <div class="pagination-container">
      <el-pagination
        v-show="total>listQuery.limit"
        :current-page="listQuery.offset"
        :page-sizes="[20,30,50]"
        :page-size="listQuery.limit"
        :total="total"
        align="center"
        layout="total, sizes, prev, pager, next"
        @size-change="handleSizeChange"
        @current-change="handleCurrentChange"/>
    </div>

    <edit-nb-device v-show="editShow" ref="editdevice" @watchChild="fetchData"/>
  </div>
</template>

<script>
import editNbDevice from '@/views/nbDevice/editNbDevice'
import selectTree from '@/components/SelectTree/singleSelect'
import { getDeviceList, delDevice, batchImportDevice, batchExportDevice } from '@/api/nbdevice'
import { downloadTemplate } from '@/api/common'
import DownloadTemplate from '@/components/DownloadTemplate/index'

export default {
  name: 'ListNbDevice',
  components: { DownloadTemplate, editNbDevice, selectTree },
  data() {
    return {
      listQuery: {
        devcode: '',
        deviceType: '',
        offset: 1,
        limit: 20,
        sort: 'id',
        order: 'asc'
      }, // 筛选条件
      columns: [
        {
          text: '设备编号',
          value: 'devcode',
          align: 'center'
        },
        {
          text: '设备唯一标识',
          value: 'nodeid',
          align: 'center'
        },
        {
          text: '验证码',
          value: 'verifyCode',
          align: 'center'
        },
        {
          text: '设备名称',
          value: 'name',
          align: 'center'
        },
        {
          text: '厂商名称',
          value: 'manufacturerName',
          align: 'center'
        },
        {
          text: '设备类型',
          value: 'deviceType',
          width: 100,
          align: 'center'
        },
        {
          text: '设备型号',
          value: 'model',
          align: 'center'
        },
        {
          text: '设备协议类型',
          value: 'protocalType',
          width: 110,
          align: 'center'
        }
      ], // 显示列
      multipleSelection: [], // 多选选中项
      list: [], // 列表数据
      total: 0, // 数据总数
      deviceTypeList: [], // 设备类型列表
      deptProps: {
        parent: 'pid',
        value: 'id',
        label: 'name',
        children: 'children'
      }, // 权属单位树形下拉菜单
      deptTreeList: null, // 组织树列表数据
      showDeptTree: 0, // 是否显示权属单位下拉
      showDeviceType: true, // 是否显示设备类型下拉
      listLoading: true, // 加载动画
      fullscreenLoading: false, // 全屏加载动画
      editShow: false, // 是否显示编辑框
      detailShow: false, // 是否显示编辑框
      filename: 'nbDevice_template.xlsx',
      fileList: []
    }
  },
  created() {
    this.fetchData()// 获取数据
  },
  methods: {
    // 打开详情对话框
    checkSelection() {
      if (this.multipleSelection.length === 0) {
        return false
      } else {
        return true
      }
    },
    // 新增设备
    add() {
      this.dialogFormVisible = true
      this.editShow = true
      this.$refs.editdevice.initDialog('create', this.dialogFormVisible)
    },
    // 编辑集中器信息
    edit(row) {
      this.dialogFormVisible = true
      this.editShow = true
      this.$refs.editdevice.initDialog('update', this.dialogFormVisible, row)
    },
    // 集中器详情
    detail(row) {
      this.dialogFormVisible = true
      this.detailShow = true
      this.$refs.detaildevice.initDialog('detail', this.dialogFormVisible, row)
    },
    // 删除集中器
    del() {
      if (this.checkSelection()) {
        // let wellNames = ''
        const concenIds = []
        this.multipleSelection.forEach(function(value, index) {
          // wellNames += value.wellCode + ','
          concenIds.push(value.id)
        })
        // wellNames = wellNames.slice(0, wellNames.length - 1)
        this.$confirm(
          '确定要删除所选设备吗？',
          '确认操作',
          {
            confirmButtonText: '确定',
            cancelButtonText: '取消',
            type: 'warning'
          }
        ).then(() => {
          delDevice(concenIds).then(response => {
            if (response.code === 200) {
              this.$message.success('删除成功')
              this.fetchData()
            }
          })
        })
      } else {
        this.$message.error('至少选中一项')
      }
    },
    // 批量导入集中器
    uploadFile(param) {
      // 判断文件大小是否符合要求
      const _file = param.file
      const isLt5M = _file.size / 1024 / 1024 < 5
      if (!isLt5M) {
        this.$message.error('请上传5M以下的excel文件')
        return false
      }
      // 全屏加载动画
      const loading = this.$loading({
        lock: true,
        text: '导入中,请稍后...',
        spinner: 'el-icon-loading',
        background: 'rgba(0, 0, 0, 0.7)'
      })
      // 发起导入请求
      batchImportDevice(_file).then(res => {
        loading.close() // 关闭加载动画
        if (res.code === 200) {
          this.$message.success('导入成功')
          this.fetchData()
        } else {
          this.$message.error(res.message)
        }
      }).catch(error => {
        loading.close() // 关闭加载动画
        this.$message.error(error.message)
      })
      this.fileList = []
    },
    // 下载模板
    downloadTemplate() {
      const filename = 'concenTemplate.xlsx'
      // 全屏加载动画
      const loading = this.$loading({
        lock: true,
        text: '下载中,请稍后...',
        spinner: 'el-icon-loading',
        background: 'rgba(0, 0, 0, 0.7)'
      })
      downloadTemplate(filename).then(res => {
        loading.close() // 关闭加载动画
        console.log('download===', res)
        const blob = new Blob([res.data])
        const downloadElement = document.createElement('a')
        const href = window.URL.createObjectURL(blob) // 创建下载的链接
        downloadElement.href = href
        downloadElement.download = `new name` // 下载后文件名
        document.body.appendChild(downloadElement)
        downloadElement.click() // 点击下载
        document.body.removeChild(downloadElement) // 下载完成移除元素
        window.URL.revokeObjectURL(href) // 释放blob对象
      }).catch((res) => {
        loading.close()
        this.$message.error(res.message)
      })
    },
    // 批量导出
    batchExport() {
      console.log('批量导出集中器')
      // 全屏加载动画
      const loading = this.$loading({
        lock: true,
        text: '下载中,请稍后...',
        spinner: 'el-icon-loading',
        background: 'rgba(0, 0, 0, 0.7)'
      })
      batchExportDevice(this.listQuery).then(res => {
        loading.close() // 关闭加载动画
        console.log('download===', res)
        const blob = new Blob([res.data])
        const downloadElement = document.createElement('a')
        const href = window.URL.createObjectURL(blob) // 创建下载的链接
        downloadElement.href = href
        downloadElement.download = `NB注册信息导出.xlsx` // 下载后文件名
        document.body.appendChild(downloadElement)
        downloadElement.click() // 点击下载
        document.body.removeChild(downloadElement) // 下载完成移除元素
        window.URL.revokeObjectURL(href) // 释放blob对象
      }).catch((res) => {
        loading.close()
        this.$message.error(res.message)
      })
    },
    // 查询数据
    search() {
      this.fetchData(false)
    },
    // 获取集中器数据
    fetchData(isNowPage = true) {
      this.listLoading = true
      if (!isNowPage) { // 是否显示当前页，否则跳转第一页
        this.listQuery.offset = 1
      }
      getDeviceList(this.listQuery).then(response => {
        this.list = response.data.rows
        this.total = parseInt(response.data.total)
        this.listLoading = false
      })
    },
    indexMethod(index) {
      return this.listQuery.limit * (this.listQuery.offset - 1) + index + 1
    },
    // 改变页容量
    handleSizeChange(val) {
      this.listQuery.limit = val
      this.fetchData()
    },
    // 改变当前页
    handleCurrentChange(val) {
      this.listQuery.offset = val
      this.fetchData()
    },
    // 多选触发方法
    handleSelectionChange(val) {
      this.multipleSelection = val
    }
  }
}
</script>

<style rel="stylesheet/scss" lang="scss" scoped>
  $tableTitleHeight:46px;
  .table{
    margin-bottom: 20px;
  }
  .pagination-container{
    margin-bottom: 50px;
  }
  .table-title{
    background-color:rgba(243, 243, 243, 1);
    height: $tableTitleHeight;
    .title-header{
      line-height:$tableTitleHeight;
      color: #606266;
      font-size: 15px;
      i{
        margin-left: 5px;
        margin-right: 5px;
      }
    }
  }
  .edit_btns{
    .edit_btn{
      float:right;
      margin:7px 3px;//为了需要居中显示margin-top和bottom要用$tableTitleHeight减去按钮原高度除以2
    }
  }
</style>
